from sys import setrecursionlimit
from functools import lru_cache

def solve(n: int, m: int, k: int) -> int:
    start = [1, 1]
    variants1 = []
    for variant in range(1, k + 1):
        variants1.append(variant)
    variants2 = variants1
    res = 1
    for i in range(max(n, m)):
        t = [start[0] + variants1[-1], start[1] + variants2[-1]]
        if t[0] < n:
            t[0] += variants1[-1]
            res += 1
        if t[1] < m:
            t[1] += variants2[-1]
            res += 1
        if t[0] > n:
            t[0] -= variants1[-1]
            variants1.pop()
        if t[1] > m:
            t[1] -= variants2[-1]
            variants2.pop()
    return max(len(variants2), len(variants1))

def main():
    n, m, k = map(int, input().split())
    print(solve(n, m, k))

if __name__ == '__main__':
    setrecursionlimit(10**9)
    main()