from sys import setrecursionlimit
from math import sqrt, prod
from functools import lru_cache

@lru_cache(None)
def solve(l: int, r: int) -> int:
    k = 0
    for i in range(int(sqrt(l)) + 1, int(sqrt(r)) + 1):
        if '0' in str(i):
            continue
        else:
            prod_of_digits = prod([int(x) for x in str(i)])
            d = 0
            for j in range(1, int(sqrt(prod_of_digits)) + 1):
                if prod_of_digits % j == 0:
                    d += 1
                    b = prod_of_digits // j
                    if b != j:
                        d += 1
            if d == 2:
                k += 1
    return k**2 + 1

@lru_cache(None)
def main():
    l = input()
    r = input()
    print(solve(int(l), int(r)))

if __name__ == '__main__':
    setrecursionlimit(10 ** 9)
    main()
