from sys import setrecursionlimit
from math import sqrt, prod
from typing import List

def is_prime(n: int) -> bool:
    dels = []
    for j in range(1, int(sqrt(n)) + 1):
        if n % j == 0:
            dels.append(j)
            b = n // j
            if b != j:
                dels.append(b)
    if len(dels) == 2:
        return True
    return False

def solve(l: str, r: str) -> int:
    k = 0
    r = int(r)
    l = int(l)
    for i in range(l, r + 1):
        sum_of_digits = prod([int(x) for x in str(i)])
        if is_prime(int(sum_of_digits)):
            k += 1
    return k
def main():
    l = input()
    r = input()
    print(solve(l,r))

if __name__ == '__main__':
    setrecursionlimit(10**9)
    main()